/*
	Project.h

	Project manager class

	Copyright (C) 2002 Dusk to Dawn Computing, Inc.

	Author: Jeff Teunissen <deek@d2dc.net>
	Date:	29 May 2002

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

	See the GNU General Public License for more details.

	You should have received a copy of the GNU General Public
	License along with this program; if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place - Suite 330
		Boston, MA  02111-1307, USA
*/

#ifndef Project_h
#define Project_h

#ifdef HAVE_CONFIG_H
# include "Config.h"
#endif

#include <Foundation/NSObject.h>

#include <AppKit/NSNibDeclarations.h>

@interface Project: NSObject
{
	IBOutlet id			owner;
	IBOutlet NSWindow	*window;
	NSMutableArray		*rFiles;
	NSMutableArray		*imgFiles;
	NSMutableArray		*suppFiles;
	NSMutableArray		*otherFiles;
}

- (void) createProjectAtPath: (NSString *) aPath;
- (void) openProjectAtPath: (NSString *) aPath;
- (void) closeProject: (id) sender;

@end

#endif//Project_h
